Ruby trunk - Bug #13898

Block parsing regression
09/14/2017 09:18 PM - tt (Troels Thomsen)

Status: Rejected
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4:
UNKNOWN

Description
Upgrading to Ruby 2.4.2p198 from Ruby 2.4.1p111 introduces the following regression:

irb(main) :001:0> def let(x, &b); end

=> :let

irb(main) :002:0> let :foo { nil }

SyntaxError: (irb) :2: syntax error, unexpected '{', expecting end-of-input
let :foo { nil }

A

from /home/tt/.rubies/ruby-2.4.2/bin/irb:11:in "~ <main>'

Related issues:

Related to Ruby trunk - Bug #13547: [].delete 1 { 'NG' } Closed
Has duplicate Ruby trunk - Bug #13939: Ruby 2.4.2 has issue supporting Seattl... Rejected
Has duplicate Ruby trunk - Bug #13976: SyntaxError if curly brace block follo... Closed
History

#1 - 09/14/2017 09:21 PM - tt (Troels Thomsen)

let(:foo) { nil } and let :foo do nil end (and let(:foo) do nil end) works.

#2 - 09/15/2017 02:24 AM - nobu (Nobuyoshi Nakada)
- Related to Bug #13547: [].delete 1 { 'NG'} added

#3 - 09/15/2017 02:24 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Rejected

#4 - 09/15/2017 07:58 PM - markus_d (Markus Doits)
Just got this error too after an update from 2.4.1 to 2.4.2.

Is this really the correct way to break the syntax in minor updates? | mean, going from 2.4 to 2.5 | might expect some syntax changes, but 2.4.1 to
2.4.2 should not break the syntax IMO (even if the behavior was not intended in the first place), even thought ruby does not follow semver.

At least an entry should be added to the changelog and/or caveats section.

#5 - 09/25/2017 09:30 PM - nobu (Nobuyoshi Nakada)
- Has duplicate Bug #13939: Ruby 2.4.2 has issue supporting Seattle.rb style for define_method added

#6 - 10/05/2017 08:00 AM - shyouhei (Shyouhei Urabe)
- Has duplicate Bug #13976: SyntaxError if curly brace block follows args without parentheses, introduced in 2.4.2 added
